// Author: Professor William Killian
// Date: 2019 July
// Class: CSCI 362.93 - Data Structures
// Assignment: 8 - Graph Algorithms
//
// Description:
//
// A basic Disjoint Set class

#include <vector>

class DisjointSet
{
public:
  // creates a new disjoint set with each element separated
  DisjointSet (size_t N) noexcept;

  // performs a lookup on a value and returns the owning set
  size_t
  findSet (size_t i) noexcept;

  // returns true IFF i and j are members of the same set
  bool
  isSameSet (size_t i, size_t j) noexcept;

  // unions the two sets of which i and j belong
  void
  unionSet (size_t i, size_t j) noexcept;

  // returns the total number of elements in the set
  size_t
  size () const noexcept;

  // returns the size of the set of which i belongs
  size_t
  size (size_t i) noexcept;

  // returns the total count of unique sets
  size_t
  set_count () const noexcept;

private:
  std::vector<size_t> m_parent, m_rank, m_sizes;
  size_t m_setcount;
};
