// Author: Professor William Killian
// Date: 2019 July
// Class: CSCI 362.93 - Data Structures
// Assignment: 8 - Graph Algorithms
//
// Description:
//
// Brief Driver program showing topological sort and kruskal's

#include <iostream>

#include "GraphAlgorithms.hpp"

int
main ()
{
  // ----- Showing API/usage for traversals

  Graph g;
  g.addEdge (161, 162, 1);
  g.addEdge (140, 330, 1);
  g.addEdge (140, 340, 1);
  g.addEdge (140, 362, 1);
  g.addEdge (140, 370, 1);
  g.addEdge (162, 330, 1);
  g.addEdge (162, 340, 1);
  g.addEdge (162, 362, 1);
  g.addEdge (162, 370, 1);
  g.addEdge (330, 420, 1);
  g.addEdge (370, 380, 1);
  g.addEdge (362, 366, 1);
  g.addEdge (362, 420, 1);
  g.addEdge (362, 380, 1);
  g.addEdge (362, 450, 1);
  g.addEdge (362, 395, 1);
  g.addEdge (362, 415, 1);

  std::cout << "Topological Sort:\n";
  for (auto const v : GraphUtils::topological_sort (g))
  {
    std::cout << v << ' ';
  }
  std::cout << '\n' << '\n';

  // ----- Showing API/usage for printing edge information -----

  Graph g2;
  auto add = [&g2](char s, char d, double w) {
    g2.addEdge (s - 'A', d - 'A', w);
    g2.addEdge (d - 'A', s - 'A', w);
  };
  add ('A', 'B', 2);
  add ('A', 'D', 1);
  add ('A', 'C', 2);
  add ('B', 'D', 5);
  add ('B', 'E', 1);
  add ('E', 'D', 1);
  add ('E', 'G', 3);
  add ('G', 'D', 5);
  add ('G', 'F', 10);
  add ('F', 'D', 6);
  add ('F', 'C', 2);
  add ('C', 'D', 1);

  std::cout << "Kruskals:\n";
  for (auto const& [s, d, w] : GraphUtils::kruskals (g2))
  {
    std::cout << '(' << s << ',' << d << ')' << '=' << w << '\n';
  }
  std::cout << '\n';

  return 0;
}
