// Author: Professor William Killian
// Date: 2019 July
// Class: CSCI 362.93 - Data Structures
// Assignment: 8 - Graph Algorithms
//
// Description:
//
// A subset of graph algorithms which operate on
// graphs represented with an adjacency list

#include <iostream>
#include "Graph.hpp"

namespace GraphUtils
{

using EdgeList = typename Graph::EdgeList;

std::vector<size_t>
bfs (Graph const& g, size_t start = 0);

std::vector<size_t>
dfs (Graph const& g, size_t start = 0);

std::vector<size_t>
topological_sort (Graph const& g);

EdgeList
prims (Graph const& g, size_t start = 0);

EdgeList
kruskals (Graph const& g);

EdgeList
dijkstra (Graph const& g, size_t start = 0);

EdgeList
bellman_ford (Graph const& g, size_t start = 0);

}
